declare PCIb {
/* $Source: /home/nagami/src/master/dlx/PCIb.h,v $
** $Author: nagami $
** $Name:  $
** $Date: 1998/11/23 05:15:42 $
** $Revision: 1.3 $
** $State: Exp $ */

/**********************************++**********************************/
/*  Access Interface                                                  */
/**********************************++**********************************/
    /* Control signals */
    instrout Ready;
    instrout Reset;
    instrout BusError;

    /* Data access signals */
    input AdrIn<32>;  output AdrOut<32>;
    input BeIn<4>;    output BeOut<4>;
    input DataIn<32>; output DataOut<32>;
    instrin ReadMem;
    instrin ReadMemLine;
    instrin WriteMem;
    instrin ReadIO;
    instrin WriteIO;
    instrin ReadConfig;
    instrin WriteConfig;
    instrout ReadDone;
    instrout WriteDone;
    instrout AccessError;

    instrout ReadMemReq;
    instrout ReadMemLineReq;
    instrout WriteMemReq;
    instrout ReadIOReq;
    instrout WriteIOReq;
    instrin ReadReqDone;
    instrin WriteReqDone;
    instrin ReqError;

/**********************************++**********************************/
/*  PCI interface                                                     */
/**********************************++**********************************/
    /* System pins */
    input nRST;

    /* Address and data pins */
    input ADin<32>;   output ADout<32>;   instrout ADenb;
    input nC_BEin<4>; output nC_BEout<4>; instrout C_BEenb;
    input PARin;      output PARout;      instrout PARenb;

    /* Interface control pins */
    input nFRAMEin;   output nFRAMEout;   instrout FRAMEenb;
    input nIRDYin;    output nIRDYout;    instrout IRDYenb;
    input nTRDYin;    output nTRDYout;    instrout TRDYenb;
    input nSTOPin;    output nSTOPout;    instrout STOPenb;
    instrin IDSEL;
    input nDEVSELin;  output nDEVSELout;  instrout DEVSELenb;
                      output nREQout;     instrout REQenb;
    input nGNT;
    input nPERRin;    output nPERRout;    instrout PERRenb;
    instrout SERRenb;

/**********************************++**********************************/
/*  Instruct Arguments                                                */
/**********************************++**********************************/
    instr_arg ReadMem    (AdrIn, BeIn);
    instr_arg ReadMemLine(AdrIn, BeIn);
    instr_arg WriteMem   (AdrIn, BeIn, DataIn);
    instr_arg ReadIO     (AdrIn, BeIn);
    instr_arg WriteIO    (AdrIn, BeIn, DataIn);
    instr_arg ReadConfig (AdrIn, BeIn);
    instr_arg WriteConfig(AdrIn, BeIn, DataIn);

    instr_arg ReadReqDone(DataIn);
    instr_arg WriteReqDone();
    instr_arg ReqError();

    instr_arg IDSEL();
    /* In your `PCI' module, you should declare these instr_arg's. */
    /*
    instr_arg Ready();
    instr_arg Reset();
    instr_arg BusError();
    instr_arg ReadDone(DataOut);
    instr_arg WriteDone();
    instr_arg AccessError();

    instr_arg ReadMemReq    (AdrOut, BeOut);
    instr_arg ReadMemLineReq(AdrOut, BeOut);
    instr_arg WriteMemReq   (AdrOut, BeOut, DataOut);
    instr_arg ReadIOReq     (AdrOut, BeOut);
    instr_arg WriteIOReq    (AdrOut, BeOut, DataOut);

    instr_arg ADenb    (ADout);
    instr_arg C_BEenb  (nC_BEout);
    instr_arg PARenb   (PARout);
    instr_arg FRAMEenb (nFRAMEout);
    instr_arg IRDYenb  (nIRDYout);
    instr_arg TRDYenb  (nTRDYout);
    instr_arg STOPenb  (nSTOPout);
    instr_arg DEVSELenb(nDEVSELout);
    instr_arg REQenb   (nREQout);
    instr_arg PERRenb  (nPERRout);
    instr_arg SERRenb  ();
     */
}
